package      Util::DependSet;
use          Exporter ();
@ISA       = qw(Exporter);

use strict;

use Util::Set;
use Util::List;

sub new ()
{
  my $self = {};
  $self->{list} = Util::List::new();
  $self->{set}  = Util::Set::new();
  return bless $self;
}

sub get_size ($)
{
  my $self = shift;

  return Util::List::size($self->{list});
}

sub add_elem ($$)
{
  my $self = shift;
  my $elem = shift;
  my $res  = Util::Set::add_elem($self->{set}, $elem);

  if ($res == 0)
  {
    Util::List::add_elem($self->{list}, $elem);
  }
  return $res;
}

sub to_string ($$)
{
  my $self      = shift;
  my $seperator = shift;

  return Util::List::to_string($self->{list}, $seperator);
}
