package lmf.formula.csp.gui;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;

import lmf.formula.csp.node.ACspConstantCallExpr;
import lmf.formula.csp.node.TMultiLineComment;
import lmf.formula.csp.node.TSingleLineComment;
import lmf.formula.csp.node.Token;

/*
 * @SuppressWarnings("serial")
 */

public class CspJTreeCellRenderer extends DefaultTreeCellRenderer {

	@Override
	public Component getTreeCellRendererComponent(JTree tree, Object treeNode,
			boolean b2, boolean b3, boolean b4, int i, boolean b6) {
		Component c = super.getTreeCellRendererComponent(tree, treeNode,
				b2, b3, b4, i, b6);
		DefaultMutableTreeNode dtn = (DefaultMutableTreeNode) treeNode; 
		Object o = dtn.getUserObject();

		if (o instanceof ACspConstantCallExpr) {
			String name = ((ACspConstantCallExpr) o).getClass().getSimpleName();
			name += "     :" + ((ACspConstantCallExpr) o).getCspType();
			this.setText(name);
			this.setFont(new Font(getFont().getFamily(), Font.BOLD, 12));
			c.setForeground(new Color(0x00,0x88,0x88));
		} else if (o instanceof TMultiLineComment) {
			String temp = ((TMultiLineComment) o).getText();
			temp = temp.replaceAll("\n\r", "\n");
			temp = temp.replaceAll("\r\n", "\n");

			String[] temp2 = temp.split("\n");
			String name = o.getClass().getSimpleName();
			for (String t : temp2) {
				dtn.add(new DefaultMutableTreeNode(t));
			}
			this.setText(name);
			c.setForeground(new Color(0x00,0x99,0x00));
		} else if (o instanceof TSingleLineComment) {
			c.setForeground(new Color(0x00,0x99,0x00));
		} else if (o instanceof Token) {
			String name = ((Token) o).getText();
			this.setText(name);
			c.setForeground(new Color(0x99,0x00,0x00));
		} else {
			c.setForeground(new Color(0x00,0x00,0x99));
		}
		return c;
	}
}
