package      Util::List;
use          Exporter ();
@ISA       = qw(Exporter);

use strict;

sub new ()
{
  my $self = [];
  $self->[0] = 0;
  return bless $self;
}

sub get_size ($)
{
  my $self = shift;

  return $self->[0];
}

sub add_elem ($$)
{
  my $self = shift;
  my $elem = shift;
  my $len  = $self->[0]+1;
 
  $self->[0] = $len;
  $self->[$len] = $elem;
  
  return $len;
}

sub set_elem_at ($$$)
{
  my $self = shift;
  my $elem = shift;
  my $pos  = shift;

  if ($pos < 1 || $pos > $self->[0])
  {
    die "Cannot set unknown list element.\nError";
  }
  $self->[$pos] = $elem;
  
  return;
}

sub get_elem_at ($$)
{
  my $self = shift;
  my $pos  = shift;

  if ($pos < 1 || $pos > $self->[0])
  {
    die "Cannot get unknown list element (".$pos.").\nError";
  }
  return $self->[$pos];
}

sub get_elem_pos ($$)
{
  my $self = shift;
  my $elem = shift;

  my $len = $self->[0];
  my $pos = -1;
  my $cnt;
  
  for ($cnt = 1; $cnt <= $len; $cnt++)
  {
    if ($self->[$cnt] =~ /^$elem$/)
    {
      $pos = $cnt;
      last;
    }
  }
  return $pos;
}

sub to_string ($$)
{
  my $self      = shift;
  my $seperator = shift;
  my $line = "";

  my $len = $self->[0];
  my $cnt;
  
  for ($cnt = 1; $cnt < $len; $cnt++)
  {
    $line = $line.$self->[$cnt].$seperator;
  }
  if ($len > 0)
  {
    $line = $line.$self->[$cnt];
  }
  return $line;
}

sub to_table_string ($$@)
{
  my $col_sep = shift;
  my $row_sep = shift;
  my @lists   = @_;

  my $cols = scalar(@lists);
  my $rows;
  my $line = "";
  my ($c, $r);

  if ($cols > 0)
  { 
    $rows = $lists[0]->[0];

    for ($c = 1; $c < $cols; $c++)
    {
      if ($lists[$c]->[0] != $rows)
      {
        die "Each column in the table must have the ".
          "same number of rows.\nError";
      }
    }
    $cols--;
    for ($r = 1; $r < $rows; $r++)
    {
       for ($c = 0; $c < $cols; $c++)
       {
         $line = $line.$lists[$c]->[$r].$col_sep;
       }
       $line = $line.$lists[$cols]->[$r].$row_sep;
    }
    if ($rows > 0)
    {
       for ($c = 0; $c < $cols; $c++)
       {
         $line = $line.$lists[$c]->[$r].$col_sep;
       }
       $line = $line.$lists[$cols]->[$r];
    }
  }
  return $line;
}
