% LaTeX2e anthony style file

% #### IDENTIFICATION #### %

\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{MasRep}[2003/03/25]


% #### INITIAL CODE #### %

\RequirePackage{float}
\RequirePackage{ifthen}
\newboolean{MasCommon@pdf}
\setboolean{MasCommon@pdf}{false}

\AtEndOfClass{%
  \MasCommon@PageLayout%
}

% #### DECLARATION OF OPTIONS #### %

\DeclareOption{sf}{\AtEndOfClass{\renewcommand\familydefault{\sfdefault}}}
\DeclareOption{rm}{\AtEndOfClass{\renewcommand\familydefault{\rmdefault}}}

\DeclareOption{a4paper}{
  \PassOptionsToClass{a4paper}{report}
}

\DeclareOption{pdftex}{
  \setboolean{MasCommon@pdf}{true}
  \PassOptionsToClass{pdftex}{report}
}

\DeclareOption{landscape}{\OptionNotUsed
  \typeout{Class does not support landscape mode}
}
\DeclareOption{fixfigure}{\AtEndOfClass{\floatplacement{figure}{H}}}
\DeclareOption{fixtable}{\AtEndOfClass{\floatplacement{table}{H}}}

\DeclareOption*{\PassOptionsToClass{\CurrentOption}{report}}

% #### EXECUTE OPTIONS #### %

\ExecuteOptions{a4paper}
\ProcessOptions

% #### PACKAGE LOADING #### %

\LoadClass{report}

% #### MAIN CODE #### %

\renewcommand\chapter{\if@openright\cleardoublepage\else\clearpage\fi
                      \thispagestyle{hdrftrii}%
                      \global\@topnum\z@
                      \@afterindentfalse
                      \secdef\@chapter\@schapter}
  
\renewcommand{\chaptermark}[1]{\markboth{\textsl{\thechapter\ #1}}{}}

\RequirePackage{MasCommon}

\MasCommon@headinglevel=0
\MasCommon@setheading{\MasCommon@headinglevel}

\def\advanceheading#1{%
  \advance\MasCommon@headinglevel by #1
  \ifnum\MasCommon@headinglevel<0%
    \MasCommon@headinglevel=0
    \typeout{Warning tried to reset heading level before 0}%
  \else%
    \ifnum\MasCommon@headinglevel>3%
      \typeout{Warning heading levels after 3 treated as heading level 3}%
    \fi%
  \fi%
  \MasCommon@setheading{\MasCommon@headinglevel}%
}

\renewcommand{\maketitle}{\MasCommon@maketitle\thispagestyle{hdrftrii}}

\endinput
