package csp2hc.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;

import sun.security.krb5.Asn1Exception;


/**
 * Menu chamado para salvar um programa antes que haja alguma operacao de carregar uma nova especificacao,
 * carregar um programa salvou ou fechar o CRefine
 * @author alessandro87
 *
 */
public class SaveDialog extends JDialog {

	private JButton save;
	private JButton discard;
	private JButton cancel;
	private JLabel label;
	private SaveChanges answer;
	private boolean toQuit;
	
	public SaveDialog (String nome, boolean twoQuit){
		this.setTitle(nome);
		this.setModal(true);
		this.setResizable(true);
		this.setLayout(null);
		answer = SaveChanges.CANCELAR;
		toQuit = twoQuit;
		jbInit();
		
	}
	
	public SaveChanges getAnswer(){
		return answer;
	}
	
	private void jbInit() {
		
		this.setLocation(250, 200);
		this.setSize(400, 110);
		
		
		label = new JLabel("Do you want to save your changes or discard them?");
		label.setLocation(15, 10);
		label.setSize(500, 20);
		
		save = new JButton("SAVE");
		save.setSize(80, 20);
		save.setLocation(label.getX() + 20, label.getY() + 40);
		save.addActionListener(new ActionListener(){

			public void actionPerformed(ActionEvent e) {
				salvarAlteracoes();
			}
			
		});
		
		cancel = new JButton("CANCEL");
		cancel.setSize(120,20);
		cancel.setLocation(save.getX() + save.getWidth() + 10, save.getY());
		cancel.addActionListener(new ActionListener(){

			public void actionPerformed(ActionEvent e) {
				cancelar();
			}
			
		});
		
		discard = new JButton("DISCARD");
		discard.setSize(100, 20);
		discard.setLocation(cancel.getX() + cancel.getWidth() + 10, save.getY());
		discard.addActionListener( new ActionListener(){

			public void actionPerformed(ActionEvent e) {
				discartarAlteracoes();
			}
			
		});
		
		add(save);
		if (!toQuit) {
			add(cancel);
		}
		
		add(label);
		add(discard);
		
	}

	protected void discartarAlteracoes() {
		answer = SaveChanges.DESCARTAR_ALTERACOES;
		this.setVisible(false);
	}

	protected void cancelar() {
		answer = SaveChanges.CANCELAR;
		this.setVisible(false);
	}
	
	protected void descartarTodos() {
		answer = SaveChanges.DESCARTAR_TODOS;
		this.setVisible(false);
	}

	protected void salvarAlteracoes() {
		answer = SaveChanges.SALVAR_ALTERACOES;
		this.setVisible(false);
	}
}
