package csp2hc.util;

import java.util.Hashtable;
import java.util.Stack;

import csp2hc.visitors.ProcessesInfoVisitor;

import lmf.formula.csp.analysis.ExtendedDepthFirstAdapter;
import lmf.formula.csp.node.ACspAlphabetisedParallelProcess;
import lmf.formula.csp.node.ACspInterleaveProcess;
import lmf.formula.csp.node.ACspProcessCallExpr;
import lmf.formula.csp.node.ACspSharingParallelProcess;
import lmf.formula.csp.node.Node;

public class BranchUtil {
	private Stack<Integer> ctx;
    // Maps each node of the tree to its branch
    private Hashtable<Integer, Integer> ctxBranches;
    
    static public int getBranchesInProcess (ProcessesInfoVisitor procInfo, Node definition){
    	return new ExtendedDepthFirstAdapter() {
    		private int parallelBranches = 1;
    		private String currentDefinition = "";
    		private ProcessesInfoVisitor procInfo;
    		public void caseACspProcessCallExpr(ACspProcessCallExpr node) {
    			String pname = node.getName().getText().trim();
    			if (!pname.equals(CspUtil.getSkip()) 
    	        		&& !pname.equals(CspUtil.getStop())
    	        		&& !this.currentDefinition.equals(pname)) {
    				this.currentDefinition = pname;
    				this.procInfo.getProcDefinition(pname).apply(this);
    			}
    		};
    		public void caseACspSharingParallelProcess(ACspSharingParallelProcess node) {
    			node.getLeftProcess().apply(this);
    			this.parallelBranches ++;
    			node.getRightProcess().apply(this);
    		}
    		public void caseACspInterleaveProcess(ACspInterleaveProcess node) {
    			node.getLeftProcess().apply(this);
    			this.parallelBranches ++;
    			node.getRightProcess().apply(this);
    		}
    		public void caseACspAlphabetisedParallelProcess(ACspAlphabetisedParallelProcess node) {
    			node.getLeftProcess().apply(this);
    			this.parallelBranches ++;
    			node.getRightProcess().apply(this);
    		}
    		public int getParallelBranches(ProcessesInfoVisitor procInfo, String name){
    			this.procInfo = procInfo;
    			this.procInfo.getProcDefinition(name).apply(this);
    			return parallelBranches;
    		}
    		public int getParallelBranches(ProcessesInfoVisitor procInfo, Node node){
    			this.procInfo = procInfo;
    			node.apply(this);
    			return parallelBranches;
    		}
    	}.getParallelBranches(procInfo, definition);
    }
}
