/*
 * LoggedStack.java
 *
 * Created on 02 February 2006, 13:25
 */

package csp2hc.util;

import java.util.*;

import csp2hc.messages.HandelC;

/**
 *
 * @author  marcel
 * A look-up table that maps channel names to Branch2BranchSetLUT
 */
public class ForcedInterleavingOnChannel extends Hashtable<String, Branch2BranchSetLUT> {
    // CHANNEL NAME -> Branch2BranchSetLUT
	
	public Branch2BranchSetLUT get(String c) {
		Branch2BranchSetLUT retorno = new Branch2BranchSetLUT();
		if(containsKey(c)) {
			retorno = super.get(c);
		}
		return retorno;
	}
	
    public void update(Set leftIds, Set rightIds, Set channels) {
        for (Iterator keys = channels.iterator(); keys.hasNext();) {
			String channel_name = HandelC.getInstance().getChannelName((String)keys.next());
			Branch2BranchSetLUT channelLUT = this.get(channel_name);
	        channelLUT = Branch2BranchSetLUT.getBranch2BranchSetLUT(leftIds, rightIds, channelLUT);
	        this.put(channel_name,channelLUT);
		} 
    }

}
