package csp2hc.visitors;

import java.util.Set;

import lmf.formula.csp.analysis.ExtendedDepthFirstAdapter;
import lmf.formula.csp.node.ACspAssert;
import lmf.formula.csp.node.Node;
import csp2hc.exception.KeywordException;
import csp2hc.messages.HandelC;
import csp2hc.messages.Messenger;

public class KeywordsVisitor extends ExtendedDepthFirstAdapter {

	private Set<String> hcKeywords;
	private Set<String> toolKeywords;
	
    public KeywordsVisitor() {
    	this.hcKeywords = HandelC.getInstance().getHCKeywords();
    	this.toolKeywords = HandelC.getInstance().getToolKeywords();
    }
    	
    public void defaultCase(Node node) {
    	String word = node.toString().trim();
    	if (this.hcKeywords.contains(word)) {
    		throw new KeywordException(word, Messenger.HANDEL_C);
    	}
    	if (this.toolKeywords.contains(word)) {
    		throw new KeywordException(word, Messenger.TRANSLATOR);
    	}
    }

}
