package csp2hc.core;

import java.io.*;
import java.util.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;

import lmf.formula.csp.node.*;
import lmf.formula.csp.lexer.*;
import lmf.formula.csp.parser.*;
import lmf.formula.csp.analysis.*;

import csp2hc.util.InsertionOrderHashMap;
import csp2hc.exception.UnsupportedConstructorException;

class InitialsExtractorVisitor extends ExtendedDepthFirstAdapter {
    private static int COMMUNICATION_INDEX = 0;
    private static int PROCESS_INDEX = 1;
    
    private InsertionOrderHashMap initials;
    
    public InitialsExtractorVisitor() {
        this.initials = new InsertionOrderHashMap();
    }

    public List keyList() { return this.initials.keyList(); }
    public LinkedList getCommunication(PEvent event) {
        return (LinkedList)((List)this.initials.get(event)).get(COMMUNICATION_INDEX);
    }
    public PPrefixProcess getProcess(PEvent event) {
        return (PPrefixProcess)((List)this.initials.get(event)).get(PROCESS_INDEX);
    }
    
    
    public void caseACspPrefixProcess(ACspPrefixProcess node){
        PEvent event = node.getEvent();
        LinkedList comm = node.getComunication();
        PPrefixProcess proc = node.getProcess();
        
        //if (comm.size()==0) {
            Vector data = new Vector();
            data.add(COMMUNICATION_INDEX,comm);
            data.add(PROCESS_INDEX,proc);
            this.initials.put(event,data);
        //} else {
            //throw new UnsupportedConstructorException(node.toString());
        //}
    }
}
