package csp2hc.gui;


import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class LogWindow{
    // GUI
    public static String LOG_WINDOW = "Log Window";
    public static String CLOSE = "Close";
    
    private JFrame f; //Main frame
    private JTextArea ta; // Text area
    private JScrollPane sbrText; // Scroll pane for text area
    private JButton btnQuit; // Quit Program

    public LogWindow(){ //Constructor
        // Create Frame
        f = new JFrame(LOG_WINDOW);
        f.getContentPane().setLayout(new FlowLayout());

        // Create Scrolling Text Area in Swing
        ta = new JTextArea("", 50, 50);
        ta.setLineWrap(true);
        ta.setWrapStyleWord(true);
        ta.setAlignmentY(JTextArea.BOTTOM_ALIGNMENT);
        
        sbrText = new JScrollPane(ta);
        sbrText.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        sbrText.setAutoscrolls(true);
        
        ta.setEditable(false);
        
        // Create Quit Button
        btnQuit = new JButton(CLOSE);
        btnQuit.addActionListener(
            new ActionListener(){
                public void actionPerformed(ActionEvent e){
                    System.exit(0);
                }
            }
        );

    }

    public void launchFrame(){ // Create Layout
        // Add text area and button to frame
        f.getContentPane().add(sbrText);
        f.getContentPane().add(btnQuit);

         // Close when the close button is clicked
        f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Display Frame
        f.pack(); // Adjusts frame to size of components
        f.setVisible(true);
    }

    public void addText(String text) {
        this.ta.append(text);
        this.ta.setCaretPosition(this.ta.getDocument().getLength());
    }
    
    
    public static void main(String args[]){
        LogWindow gui = new LogWindow();
        gui.launchFrame();
    }
}
