/*
 * ListUtil.java
 *
 * Created on 20 January 2006, 12:29
 */

package csp2hc.util;

import java.util.*;
import csp2hc.messages.*;
import csp2hc.util.exception.*;

/**
 *
 * @author  marcel
 */
public class ListUtil {
    
    public static List reverse(List list) {
        List reverse = new Vector();
        for (int i=list.size()-1; i>=0; i--) {
            reverse.add(list.get(i));
        }
        
        return reverse;
    }
    
    public static List elementToList(Object o) {
        List answer = new Vector();
        answer.add(o);
        return answer;
    }

    public static List elementToList(List l) {
        List answer = new Vector();
        for(int i=0; i<l.size(); i++) {
            answer.add(ListUtil.elementToList(l.get(i)));
        }
        return answer;
    }
    
    public static List cartesianProduct(List lists) {
        List answer = new Vector();
        
        for(int i=0; i<lists.size(); i++) {
            if (!(lists.get(i) instanceof List)) {
                throw new InvalidListOperation(Messenger.CART_PROD_INVALID_LIST_OF_LISTS);
            }
        }

        if (lists.size() == 0) {
            answer = lists;
        } else if (lists.size() == 1) {
            answer = ListUtil.elementToList((List)lists.get(0));
        } else {
            List xs = (List)ListUtil.head(lists);
            List xss = ListUtil.tail(lists);
            
            List xssCartProd = ListUtil.cartesianProduct(xss);

            for (int i=0; i<xs.size(); i++){
                Object a = xs.get(i);
                for (int j=0; j<xssCartProd.size(); j++){
                    List as = (List)xssCartProd.get(j);
                    List aCATas = ListUtil.concat(a,as);
                    answer.add(aCATas);
                }
            }
        }
        return answer;
    }
    
    public static Object head(List l) {
        if (l.size() <=0) {
            throw new InvalidListOperation(Messenger.HEAD_OF_EMPTY_LIST);
        } else {
            return l.get(0);
        }
    }
    
    public static List tail(List l) {
        if (l.size() <=0) {
            throw new InvalidListOperation(Messenger.TAIL_OF_EMPTY_LIST);
        } else if (l.size() == 1) {
            return new Vector();
        } else {
            return l.subList(1,l.size());
        }
    }

    public static Object last(List l) {
        if (l.size() <=0) {
            throw new InvalidListOperation(Messenger.LAST_OF_EMPTY_LIST);
        } else {
            return l.get(l.size()-1);
        }
    }
    
    public static List concat(Object x, List xs) {
        List answer = new Vector();
        answer.add(x);
        for(int i=0; i<xs.size(); i++) {
            answer.add(xs.get(i));
        }
        return answer;
    }

    public static List clone(List in) {
        List out = new Vector();
        for (int i=0; i < in.size(); i++) {
            out.add(in.get(i));
        }
     
        return out;
    }
    
    public static void main(String[] args) {
        List xs = new Vector();
        xs.add("A");
        xs.add("B");

        System.out.println((new ListUtil()).last(xs));
    }
}
