/*
 * LoggedStack.java
 *
 * Created on 02 February 2006, 13:25
 */

package csp2hc.util;

import java.util.*;

/**
 *
 * @author  marcel
 */
public class LoggedStack extends java.util.Stack {
    
    private boolean log;
    
    /** Creates a new instance of LoggedStack */
    public LoggedStack(boolean log) {
        this.log = log;
    }
    
    public Object push(Object o) {
        super.push(o);
        if (log) {
            System.out.println("LoggedStack :: push -> "+o);
            System.out.println("LoggedStack :: push -> Current Stack = "+ this.toString());
        }
        return o;
    }
    
    public Object pop() {
        Object o = super.pop();
        if (log) {
            System.out.println("LoggedStack :: pop -> "+ o);
            System.out.println("LoggedStack :: pop -> Current Stack = "+ this.toString());
        }
        return o;
    }

    public Object peek() {
        Object o = super.peek();
        if (log) {
            System.out.println("LoggedStack :: peek -> "+ o);
            System.out.println("LoggedStack :: peek -> Current Stack = "+ this.toString());
        }
        return o;
    }
    
    public String toString(){
        String answer = "[";
        ListIterator iterator = this.listIterator();
        
        while(iterator.hasNext()) {
            answer = answer + iterator.next();
            if (iterator.hasNext()) {
                answer = answer + "|";
            }
        }
        answer = answer + "]";
        
        return answer;
    }
    
}
