/*
 * StringUtil.java
 *
 * Created on 20 January 2006, 12:29
 */

package csp2hc.util;

import java.util.*;
import csp2hc.messages.*;

/**
 *
 * @author  marcel
 */
public class StringUtil {
    
    public static String removeExtraSpaces(String input){
        String output = "";
        StringTokenizer tokenizer = new StringTokenizer(input," ",true);

        String nextWord = "";
        Vector words = new Vector();
        while (tokenizer.hasMoreTokens()) {
            nextWord = tokenizer.nextToken();
            while(nextWord.equals(" ") && tokenizer.hasMoreTokens()) { 
                nextWord = tokenizer.nextToken();
            }
            if (!nextWord.equals(" ")) {
                words.addElement(nextWord);
            }
        }
        for (int i=0; i<words.size(); i++) {
            output = output+words.elementAt(i);
            if (i < words.size()-1) {
                output = output+" ";
            }
        }
        
        return output;
    }
    
    public static String removeBreakLines(String input){
        String output = "";
        StringTokenizer tokenizer = new StringTokenizer(input,Messenger.BREAK_LINE);
        
        while(tokenizer.hasMoreTokens()) {
            String next = (String)tokenizer.nextElement();
            output = output + next;
        }
        return output;
    }

    public static String removeReturns(String input){
        String output = "";
        StringTokenizer tokenizer = new StringTokenizer(input,Messenger.RETURN);
        
        while(tokenizer.hasMoreTokens()) {
            String next = (String)tokenizer.nextElement();
            output = output + next;
        }
        return output;
    }

    public static String removeTabs(String input){
        String output = "";
        StringTokenizer tokenizer = new StringTokenizer(input,Messenger.TAB);
        
        while(tokenizer.hasMoreTokens()) {
            String next = (String)tokenizer.nextElement();
            output = output + next;
        }
        return output;
    }

    public static String repeat(char c, int n) {
        String output = "";
        for(int i=0; i<n; i++){
            output = output + c;
        }
        return output;
    }

    public static String identation(String s, int n) {
        String output = "";
        for(int i=0; i<n; i++){
            output = output + " ";
        }
        return output + s;
    }
    
    public static String insertBreakLinesBefore(String input, String text) {
        return input.replaceAll(text,Messenger.BREAK_LINE+text);
    }

    public static String insertIndicatedBreakLines(String input) {
        return input.replaceAll(HandelC.COMMENT_LINE_BREAK,Messenger.BREAK_LINE);
    }

    public static String insertBreakLinesAfter(String input) {
        String answer = input.concat(Messenger.BREAK_LINE);
        return answer;
    }

    public static String insertIndicatedTabs(String input) {
        return input.replaceAll(HandelC.COMMENT_TAB,Messenger.TAB);
    }

    public static String insertIndicatedSpaces(String input) {
        int index = input.indexOf(HandelC.COMMENT_SPACES);
        while(index >= 0) {
            String remaining = input.substring(index+HandelC.COMMENT_SPACES.length());
            int indexOfUnderscore = remaining.indexOf(HandelC.UNDERSCORE);
            String number = remaining.substring(0,indexOfUnderscore);
            int spaces = (new Integer(number)).intValue();
            String spacesStr = "";
            for (int i = 0; i < spaces; i++) {
                spacesStr = spacesStr + HandelC.SPACE;
            }
            
            input = input.replaceAll(StringUtil.getSpace(spaces), spacesStr);
            index = input.indexOf(HandelC.COMMENT_SPACES);
        }
        return input;
    }
    
    public static String getSpace(int numberOfSpaces) {
        return HandelC.COMMENT_SPACES + numberOfSpaces + HandelC.UNDERSCORE;
    }
    
    public static void main(String[] args) {
        System.out.print(StringUtil.insertIndicatedSpaces("XXX"+StringUtil.getSpace(10)+"YYY"));
    }
}
