package lmf.formula.csp.analysis;

import lmf.formula.csp.node.ACspConstantDefinition;
import lmf.formula.csp.node.ACspFunctionDefinition;
import lmf.formula.csp.node.ACspProcessDefinition;


public class ExtendedDepthFirstAdapter extends DepthFirstAdapter {

	public void inACspProcessDefinition(ACspProcessDefinition node) {
		defaultIn(node);
	}

	public void outACspProcessDefinition(ACspProcessDefinition node) {
		defaultOut(node);
	}

	public void caseACspProcessDefinition(ACspProcessDefinition node) {
		inACspProcessDefinition(node);
		if (node.getName() != null) {
			node.getName().apply(this);
		}
		if (node.getParameters() != null) {
			node.getParameters().apply(this);
		}
		if (node.getDefs() != null) {
			node.getDefs().apply(this);
		}
		if (node.getExpression() != null) {
			node.getExpression().apply(this);
		}
		outACspProcessDefinition(node);
	}

	public void inACspFunctionDefinition(ACspFunctionDefinition node) {
		defaultIn(node);
	}

	public void outACspFunctionDefinition(ACspFunctionDefinition node) {
		defaultOut(node);
	}

	public void caseACspFunctionDefinition(ACspFunctionDefinition node) {
		inACspFunctionDefinition(node);
		if (node.getName() != null) {
			node.getName().apply(this);
		}
		if (node.getParameters() != null) {
			node.getParameters().apply(this);
		}
		if (node.getDefs() != null) {
			node.getDefs().apply(this);
		}
		if (node.getExpression() != null) {
			node.getExpression().apply(this);
		}
		outACspFunctionDefinition(node);
	}

	public void inACspConstantDefinition(ACspConstantDefinition node) {
		defaultIn(node);
	}

	public void outACspConstantDefinition(ACspConstantDefinition node) {
		defaultOut(node);
	}

	public void caseACspConstantDefinition(ACspConstantDefinition node) {
		inACspConstantDefinition(node);
		if (node.getName() != null) {
			node.getName().apply(this);
		}
		if (node.getDefs() != null) {
			node.getDefs().apply(this);
		}
		if (node.getExpression() != null) {
			node.getExpression().apply(this);
		}
		outACspConstantDefinition(node);
	}

}