package lmf.formula.csp.extractor;

import java.util.ArrayList;
import java.util.Iterator;

import lmf.formula.csp.analysis.DepthFirstAdapter;
import lmf.formula.csp.node.ACspConstrainedInputComunication;
import lmf.formula.csp.node.ACspInputComunication;
import lmf.formula.csp.node.ACspOutputComunication;
import lmf.formula.csp.node.ACspPrefixProcess;
import lmf.formula.csp.node.PComunication;


/// <summary>
/// Summary description for AlphabetExtractor.
/// </summary>
public class AlphabetExtractor extends DepthFirstAdapter {

	protected ArrayList alphabetSet = new ArrayList();

	public ArrayList getAlphabetSet() {
		return this.alphabetSet;
	}

	 public void outACspPrefixProcess(ACspPrefixProcess node) {
		String eventName = node.getEvent().toString();

		if (node.getComunication() != null) {
			Iterator it = node.getComunication().iterator();
			PComunication comm;
			while (it.hasNext()) {
				comm = (PComunication) it.next();
				if (comm instanceof ACspInputComunication
    					|| comm instanceof ACspConstrainedInputComunication) {
					eventName = eventName.concat(
						comm.toString().replaceAll("?", "."));
				} else if (comm instanceof ACspOutputComunication) {
					eventName = eventName.concat(
						comm.toString().replaceAll("!", "."));
				}
			}
		}
		this.alphabetSet.add(eventName);
	}
}
