package lmf.formula.csp.extractor;

import java.util.ArrayList;


public final class CspEventInfo {

	private String channelName;
	private ArrayList projections = new ArrayList();
	private ArrayList communications = new ArrayList();

	public CspEventInfo(String channelName) {
		this.channelName = channelName;
		this.projections = new ArrayList();
		this.communications = new ArrayList();
	}

	public CspEventInfo(String channelName, ArrayList projections) {
	    this.channelName = channelName;
		this.projections = projections;
		this.communications = new ArrayList();
	}

	public CspEventInfo(String channelName, ArrayList projections,
		   ArrayList communications) {
		this.channelName = channelName;
		this.projections = projections;
		this.communications = communications;
	}

	public String getChannelName() {
		return channelName;
	}

	public ArrayList getProjections() {
		return projections;
	}

	public ArrayList getCommunications() {
		return communications;
	}

}