package lmf.formula.csp.extractor;

import java.util.ArrayList;

import lmf.formula.csp.analysis.DepthFirstAdapter;
import lmf.formula.csp.node.ACspCallPostfixExpr;
import lmf.formula.csp.node.ACspEvent;


/// <summary>
///
/// </summary>
public class EventsExtractor extends DepthFirstAdapter {

	private CspEventInfo currentEvent;

	private ArrayList events = new ArrayList();

	public ArrayList getEvents() {
		return events;
	}

	public void inACspEvent(ACspEvent node) {
		this.currentEvent = new CspEventInfo(node.getChannelName().getText());
	}

	public void outACspEvent(ACspEvent node) {
		this.events.add(this.currentEvent);
	}

	public void inACspCallPostfixExpr(ACspCallPostfixExpr node) {
		if (this.currentEvent != null) {
			this.currentEvent.getProjections().add(node.getName().getText());
		}
	}
}
