package lmf.formula.csp.extractor;

import java.util.Hashtable;

import lmf.formula.csp.analysis.DepthFirstAdapter;
import lmf.formula.csp.node.ACspEvent;
import lmf.formula.csp.node.ACspSubstitution;


/// <summary>
/// Substitutions extractor.
/// </summary>
public class SubstitutionsExtractor extends DepthFirstAdapter {

	private Hashtable substitutions = new Hashtable();

	public Hashtable getSubstitutions() {
		return this.substitutions;
	}

	public void caseACspSubstitution(ACspSubstitution node) {
		String oldEvent = (String) getOut(node.getOldEvent());
		String newEvent = (String) getOut(node.getNewEvent());
		this.substitutions.put(oldEvent, newEvent);
	}

	public void outACspEvent(ACspEvent node) {
		String channelName = node.getChannelName().getText();
//TODO:
		// String projections = ...node.getProjection();
		setOut(node, channelName);
	}
}
