package lmf.formula.csp.node;

import lmf.formula.csp.analysis.ExtendedDepthFirstAdapter;


public final class ACspConstantDefinition extends PDefinition {

	private TName _name_;
	private TDefs _defs_;
	private PExpression _expression_;

	public ACspConstantDefinition() {
	}

	public ACspConstantDefinition(TName _name_,
			TDefs _defs_, PExpression _expression_) {
		setName(_name_);
		setDefs(_defs_);
		setExpression(_expression_);
	}

	public Object clone() {
		return new ACspConstantDefinition((TName) cloneNode(_name_),
				(TDefs) cloneNode(_defs_),
				(PExpression) cloneNode(_expression_));
	}

	public void apply(Switch sw) {
		if (sw instanceof ExtendedDepthFirstAdapter)
			((ExtendedDepthFirstAdapter) sw).caseACspConstantDefinition(this);
		else
			System.out.println("Use ExtendedDepthFirstAdapter!!!!");
	}

	public TName getName() {
		return _name_;
	}

	public void setName(TName node) {
		if (_name_ != null) {
			_name_.parent(null);
		}

		if (node != null) {
			if (node.parent() != null) {
				node.parent().removeChild(node);
			}

			node.parent(this);
		}

		_name_ = node;
	}

	public TDefs getDefs() {
		return _defs_;
	}

	public void setDefs(TDefs node) {
		if (_defs_ != null) {
			_defs_.parent(null);
		}

		if (node != null) {
			if (node.parent() != null) {
				node.parent().removeChild(node);
			}

			node.parent(this);
		}

		_defs_ = node;
	}

	public PExpression getExpression() {
		return _expression_;
	}

	public void setExpression(PExpression node) {
		if (_expression_ != null) {
			_expression_.parent(null);
		}

		if (node != null) {
			if (node.parent() != null) {
				node.parent().removeChild(node);
			}

			node.parent(this);
		}

		_expression_ = node;
	}

	public String toString() {
		return "" + toString(_name_) + toString(_defs_) + toString(_expression_);
	}

	void removeChild(Node child) {
		if (_name_ == child) {
			_name_ = null;
			return;
		}
		if (_defs_ == child) {
			_defs_ = null;
			return;
		}
		if (_expression_ == child) {
			_expression_ = null;
			return;
		}
	}

	void replaceChild(Node oldChild, Node newChild) {
		if (_name_ == oldChild) {
			setName((TName) newChild);
			return;
		}
		if (_defs_ == oldChild) {
			setDefs((TDefs) newChild);
			return;
		}
		if (_expression_ == oldChild) {
			setExpression((PExpression) newChild);
			return;
		}
	}

}