package lmf.formula.csp.semantic;

import lmf.formula.csp.node.Node;
import lmf.formula.csp.type.CspType;


/**
 * 
 * @author Joabe Jesus
 */
public abstract class CspDeclaration {

	private Node node;

	private String name;

	private int scopeLevel;

	private CspType type;

	public CspDeclaration(String name, CspType type) {
		this.name = name;
		this.type = type;
	}

	public Node getNode() {
		return node;
	}

	public void setNode(Node value) {
		node = value;
	}

	public String getName() {
		return name;
	}

	public void setName(String value) {
		name = value;
	}

	public int getScopeLevel() {
		return scopeLevel;
	}

	public void setScopeLevel(int value) {
		if (value > -1) {
			scopeLevel = value;
		}
	}

	public CspType getCspType() {
		return type;
	}

	public void setCspType(CspType value) {
		type = value;
	}

}