package lmf.formula.csp.semantic;

import java.util.ArrayList;
import java.util.Iterator;

import lmf.formula.csp.node.Node;


class CspEnvironment {

	private Node root;

	private ArrayList declarations;

	public CspEnvironment(Node root) {
		this.root = root;
		this.declarations = new ArrayList();
	}

	public CspEnvironment(Node root, CspEnvironment parent) {
		this.root = root;
		this.declarations = new ArrayList(parent.declarations);
	}

	public Node getRoot() {
		return root;
	}

	public void Bind(CspDeclaration declaration) {
		this.declarations.add(declaration);
	}

	public boolean isNameBound(CspDeclaration declaration) {
		return this.declarations.contains(declaration);
	}

	public Iterator getDeclarations() {
		return this.declarations.iterator();
	}

	public void unbind(CspDeclaration declaration) {
		this.declarations.remove(declaration);
	}

	public String toString() {
		String ret = "";
		Iterator it = this.declarations.iterator();
		while (it.hasNext()) {
			ret += it.next() + "\n";
		}
		return ret;
	}

}