/*
 * LoggedStack.java
 *
 * Created on 02 February 2006, 13:25
 */

package csp2hc.util;

import java.util.*;

/**
 *
 * @author  marcel
 * 
 * A look-up table that maps branch identifiers to sets of actions \powerset{(in or out})
 */
public class Branch2ActionSetLUT extends Hashtable<Integer, Set<String>> {
    
	public Set<String> get(Integer i) {
		Set retorno = new HashSet();
		if(containsKey(i)) {
			retorno = super.get(i);
		}
		return retorno;
	}
	
	public void add(Integer branch, String action) {
		Set current = new HashSet();
		if(containsKey(branch)) {
			current = super.get(branch);
			super.remove(branch);
		}
		current.add(action);
		super.put(branch, current);
	}
}
