/*
 * LoggedStack.java
 *
 * Created on 02 February 2006, 13:25
 */

package csp2hc.util;

import java.util.*;

/**
 *
 * @author  marcel
 * 
 * A look-up table that maps branch identifiers to sets of branch identifiers
 */
public class Branch2BranchSetLUT extends Hashtable<Integer, Set<Integer>> {
    
	public Set<Integer> get(Integer i) {
		Set retorno = new HashSet();
		if(containsKey(i)) {
			retorno = super.get(i);
		}
		return retorno;
	}
	
    public static Branch2BranchSetLUT getBranch2BranchSetLUT(Set leftIds, Set rightIds, Branch2BranchSetLUT channelLUT) {
		for (Iterator rIds = rightIds.iterator(); rIds.hasNext();) {
			Integer rightId = (Integer) rIds.next();
			for (Iterator lIds = leftIds.iterator(); lIds.hasNext();) {
				Integer leftId = (Integer) lIds.next();
		        Set leftLUT = channelLUT.get(leftId);
		        leftLUT.add(rightId);
		        channelLUT.put(leftId, leftLUT);
		        
		        Set rightLUT = channelLUT.get(rightId);
		        rightLUT.add(leftId);
		        channelLUT.put(rightId, rightLUT);
			}
		}
		return channelLUT;
    }
    
	
}
