/*
 * LoggedStack.java
 *
 * Created on 02 February 2006, 13:25
 */

package csp2hc.util;

import java.util.*;

import csp2hc.messages.HandelC;

/**
 *
 * @author  marcel
 * A look-up table that maps channel names to Branch2BranchSetLUT
 */
public class BranchActionsOnChannel extends Hashtable<String, Branch2ActionSetLUT> {
    // CHANNEL NAME -> Branch2ActionSetLUT
	
	public Branch2ActionSetLUT get(String c) {
		Branch2ActionSetLUT retorno = new Branch2ActionSetLUT();
		if(containsKey(c)) {
			retorno = super.get(c);
		}
		return retorno;
	}

    public void update(String channel, Integer branch, String action ) {
		Branch2ActionSetLUT current = new Branch2ActionSetLUT();
		if(containsKey(channel)) {
			current = this.get(channel);
			this.remove(channel);
		}
		current.add(branch, action);
		this.put(channel,current);
    }
    
}
