package csp2hc.util;

import java.io.*;

public class LineCounter
{
    public static int countLines(File file, String encoding) throws IOException
    {
        return countLines(file, encoding, '\n');
    }

    public static int countLines(File file) throws IOException
    {
        return countLines(file, "UTF-8", '\n');
    }
    
    public static int countLines(File file, String encoding, char eolChar) throws IOException
    {
        int lineCount = 0;
        Reader reader = new InputStreamReader(new FileInputStream(file), encoding);
        char[] buffer = new char[4096];
        for (int charsRead = 0; (charsRead = reader.read(buffer)) >= 0;)
        {
            for (int charIndex = 0; charIndex < charsRead ; charIndex++)
            {
                if (buffer[charIndex] == eolChar)
                    lineCount++;
            }
        }
        reader.close();
        return lineCount;
    }
}

