/*
 * StringUtil.java
 *
 * Created on 20 January 2006, 12:29
 */

package csp2hc.util;

import java.util.*;

import mathCollection.HashMathSet;
import mathCollection.HashSetOfSets;
import mathCollection.MathSet;
import mathCollection.SetOfSets;
import csp2hc.messages.*;

/**
 *
 * @author  marcel
 */
public class SetUtil {
    
	public static <T> Set<Set<T>> maximalSets(Set<Set<T>> ss) {
		HashSet<Set<T>> retorno = new HashSet<Set<T>>();
		
		for (Iterator iter = ss.iterator(); iter.hasNext();) {
			Set<T> element = (Set<T>) iter.next();
			Set<Set<T>> remaining = SetUtil.copy(ss);
			remaining.remove(element);
			
			boolean existsGreater = false;
			for(Iterator iter2 = remaining.iterator(); iter2.hasNext();) {
				Set<T> next = (Set<T>) iter2.next();
				if (next.containsAll(element)) {
					existsGreater = true;
				}
			}
			
			if (!existsGreater) {
				retorno.add(element);
			}
		}
		
		return retorno;
	}

	public static <T> Set<T> copy(Set<T> s) {
		HashSet<T> c = new HashSet<T>();
		c.addAll(s);
		return c;
	}
	
	public static void main(String[] args){
		HashSet s1 = new HashSet();

		HashSet s2 = new HashSet();
		s2.add(new Integer(1));
		
		HashSet s3 = new HashSet();
		s3.add(new Integer(1));
		s3.add(new Integer(2));

		HashSet s4 = new HashSet();
		s4.add(new Integer(1));
		s4.add(new Integer(2));
		s4.add(new Integer(3));

		HashSet s5 = new HashSet();
		s5.add(new Integer(5));

		HashSet s6 = new HashSet();
		s6.add(new Integer(3));

		HashSet ss = new HashSet();
		ss.add(s1);
		ss.add(s2);
		ss.add(s3);
		ss.add(s4);
		ss.add(s5);
		ss.add(s6);
		
		System.out.println(SetUtil.maximalSets(ss));
	}
	
    
}
